var roaring_wasm_module = function(roaring_wasm_module) {
  roaring_wasm_module = roaring_wasm_module || {}

  var Module = typeof roaring_wasm_module !== 'undefined' ? roaring_wasm_module : {}
  function process() {}
  process['argv'] = []
  process['on'] = function() {}
  process['exit'] = function() {}
  var moduleOverrides = {}
  var key
  for (key in Module) {
    if (Module.hasOwnProperty(key)) {
      moduleOverrides[key] = Module[key]
    }
  }
  Module['arguments'] = []
  Module['thisProgram'] = './this.program'
  Module['quit'] = function(status, toThrow) {
    throw toThrow
  }
  Module['preRun'] = []
  Module['postRun'] = []
  var ENVIRONMENT_IS_WEB = false
  var ENVIRONMENT_IS_WORKER = false
  var ENVIRONMENT_IS_NODE = false
  var ENVIRONMENT_IS_SHELL = false
  if (Module['ENVIRONMENT']) {
    if (Module['ENVIRONMENT'] === 'WEB') {
      ENVIRONMENT_IS_WEB = true
    } else if (Module['ENVIRONMENT'] === 'WORKER') {
      ENVIRONMENT_IS_WORKER = true
    } else if (Module['ENVIRONMENT'] === 'NODE') {
      ENVIRONMENT_IS_NODE = true
    } else if (Module['ENVIRONMENT'] === 'SHELL') {
      ENVIRONMENT_IS_SHELL = true
    } else {
      throw new Error("Module['ENVIRONMENT'] value is not valid. must be one of: WEB|WORKER|NODE|SHELL.")
    }
  } else {
    ENVIRONMENT_IS_WEB = typeof window === 'object'
    ENVIRONMENT_IS_WORKER = typeof importScripts === 'function'
    ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function' && !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_WORKER
    ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER
  }
  if (ENVIRONMENT_IS_NODE) {
    var nodeFS
    var nodePath
    Module['read'] = function shell_read(filename, binary) {
      var ret
      if (!nodeFS) nodeFS = require('fs')
      if (!nodePath) nodePath = require('path')
      filename = nodePath['normalize'](filename)
      ret = nodeFS['readFileSync'](filename)
      return binary ? ret : ret.toString()
    }
    Module['readBinary'] = function readBinary(filename) {
      var ret = Module['read'](filename, true)
      if (!ret.buffer) {
        ret = new Uint8Array(ret)
      }
      assert(ret.buffer)
      return ret
    }
    if (process['argv'].length > 1) {
      Module['thisProgram'] = process['argv'][1].replace(/\\/g, '/')
    }
    Module['arguments'] = process['argv'].slice(2)
    process['on']('unhandledRejection', function(reason, p) {
      process['exit'](1)
    })
    Module['inspect'] = function() {
      return '[Emscripten Module object]'
    }
  } else if (ENVIRONMENT_IS_SHELL) {
    if (typeof read != 'undefined') {
      Module['read'] = function shell_read(f) {
        return read(f)
      }
    }
    Module['readBinary'] = function readBinary(f) {
      var data
      if (typeof readbuffer === 'function') {
        return new Uint8Array(readbuffer(f))
      }
      data = read(f, 'binary')
      assert(typeof data === 'object')
      return data
    }
    if (typeof scriptArgs != 'undefined') {
      Module['arguments'] = scriptArgs
    } else if (typeof arguments != 'undefined') {
      Module['arguments'] = arguments
    }
    if (typeof quit === 'function') {
      Module['quit'] = function(status, toThrow) {
        quit(status)
      }
    }
  } else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
    Module['read'] = function shell_read(url) {
      var xhr = new XMLHttpRequest()
      xhr.open('GET', url, false)
      xhr.send(null)
      return xhr.responseText
    }
    if (ENVIRONMENT_IS_WORKER) {
      Module['readBinary'] = function readBinary(url) {
        var xhr = new XMLHttpRequest()
        xhr.open('GET', url, false)
        xhr.responseType = 'arraybuffer'
        xhr.send(null)
        return new Uint8Array(xhr.response)
      }
    }
    Module['readAsync'] = function readAsync(url, onload, onerror) {
      var xhr = new XMLHttpRequest()
      xhr.open('GET', url, true)
      xhr.responseType = 'arraybuffer'
      xhr.onload = function xhr_onload() {
        if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) {
          onload(xhr.response)
          return
        }
        onerror()
      }
      xhr.onerror = onerror
      xhr.send(null)
    }
    if (typeof arguments != 'undefined') {
      Module['arguments'] = arguments
    }
    Module['setWindowTitle'] = function(title) {
      document.title = title
    }
  }
  Module['print'] = typeof console !== 'undefined' ? console.log.bind(console) : typeof print !== 'undefined' ? print : null
  Module['printErr'] = typeof printErr !== 'undefined' ? printErr : (typeof console !== 'undefined' && console.warn.bind(console)) || Module['print']
  Module.print = Module['print']
  Module.printErr = Module['printErr']
  for (key in moduleOverrides) {
    if (moduleOverrides.hasOwnProperty(key)) {
      Module[key] = moduleOverrides[key]
    }
  }
  moduleOverrides = undefined
  var STACK_ALIGN = 16
  function staticAlloc(size) {
    assert(!staticSealed)
    var ret = STATICTOP
    STATICTOP = (STATICTOP + size + 15) & -16
    return ret
  }
  function dynamicAlloc(size) {
    assert(DYNAMICTOP_PTR)
    var ret = HEAP32[DYNAMICTOP_PTR >> 2]
    var end = (ret + size + 15) & -16
    HEAP32[DYNAMICTOP_PTR >> 2] = end
    if (end >= TOTAL_MEMORY) {
      var success = enlargeMemory()
      if (!success) {
        HEAP32[DYNAMICTOP_PTR >> 2] = ret
        return 0
      }
    }
    return ret
  }
  function alignMemory(size, factor) {
    if (!factor) factor = STACK_ALIGN
    var ret = (size = Math.ceil(size / factor) * factor)
    return ret
  }
  function getNativeTypeSize(type) {
    switch (type) {
      case 'i1':
      case 'i8':
        return 1
      case 'i16':
        return 2
      case 'i32':
        return 4
      case 'i64':
        return 8
      case 'float':
        return 4
      case 'double':
        return 8
      default: {
        if (type[type.length - 1] === '*') {
          return 4
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1))
          assert(bits % 8 === 0)
          return bits / 8
        } else {
          return 0
        }
      }
    }
  }
  var functionPointers = new Array(0)
  var GLOBAL_BASE = 1024
  var ABORT = 0
  var EXITSTATUS = 0
  function assert(condition, text) {
    if (!condition) {
      abort('Assertion failed: ' + text)
    }
  }
  function setValue(ptr, value, type, noSafe) {
    type = type || 'i8'
    if (type.charAt(type.length - 1) === '*') type = 'i32'
    switch (type) {
      case 'i1':
        HEAP8[ptr >> 0] = value
        break
      case 'i8':
        HEAP8[ptr >> 0] = value
        break
      case 'i16':
        HEAP16[ptr >> 1] = value
        break
      case 'i32':
        HEAP32[ptr >> 2] = value
        break
      case 'i64':
        ;(tempI64 = [value >>> 0, ((tempDouble = value), +Math_abs(tempDouble) >= +1 ? (tempDouble > +0 ? (Math_min(+Math_floor(tempDouble / +4294967296), +4294967295) | 0) >>> 0 : ~~+Math_ceil((tempDouble - +(~~tempDouble >>> 0)) / +4294967296) >>> 0) : 0)]), (HEAP32[ptr >> 2] = tempI64[0]), (HEAP32[(ptr + 4) >> 2] = tempI64[1])
        break
      case 'float':
        HEAPF32[ptr >> 2] = value
        break
      case 'double':
        HEAPF64[ptr >> 3] = value
        break
      default:
        abort('invalid type for setValue: ' + type)
    }
  }
  var ALLOC_STATIC = 2
  var ALLOC_NONE = 4
  function allocate(slab, types, allocator, ptr) {
    var zeroinit, size
    if (typeof slab === 'number') {
      zeroinit = true
      size = slab
    } else {
      zeroinit = false
      size = slab.length
    }
    var singleType = typeof types === 'string' ? types : null
    var ret
    if (allocator == ALLOC_NONE) {
      ret = ptr
    } else {
      ret = [typeof _malloc === 'function' ? _malloc : staticAlloc, stackAlloc, staticAlloc, dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length))
    }
    if (zeroinit) {
      var stop
      ptr = ret
      assert((ret & 3) == 0)
      stop = ret + (size & ~3)
      for (; ptr < stop; ptr += 4) {
        HEAP32[ptr >> 2] = 0
      }
      stop = ret + size
      while (ptr < stop) {
        HEAP8[ptr++ >> 0] = 0
      }
      return ret
    }
    if (singleType === 'i8') {
      if (slab.subarray || slab.slice) {
        HEAPU8.set(slab, ret)
      } else {
        HEAPU8.set(new Uint8Array(slab), ret)
      }
      return ret
    }
    var i = 0,
      type,
      typeSize,
      previousType
    while (i < size) {
      var curr = slab[i]
      type = singleType || types[i]
      if (type === 0) {
        i++
        continue
      }
      if (type == 'i64') type = 'i32'
      setValue(ret + i, curr, type)
      if (previousType !== type) {
        typeSize = getNativeTypeSize(type)
        previousType = type
      }
      i += typeSize
    }
    return ret
  }
  function Pointer_stringify(ptr, length) {
    if (length === 0 || !ptr) return ''
    var hasUtf = 0
    var t
    var i = 0
    while (1) {
      t = HEAPU8[(ptr + i) >> 0]
      hasUtf |= t
      if (t == 0 && !length) break
      i++
      if (length && i == length) break
    }
    if (!length) length = i
    var ret = ''
    if (hasUtf < 128) {
      var MAX_CHUNK = 1024
      var curr
      while (length > 0) {
        curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)))
        ret = ret ? ret + curr : curr
        ptr += MAX_CHUNK
        length -= MAX_CHUNK
      }
      return ret
    }
    return UTF8ToString(ptr)
  }
  var UTF8Decoder = typeof TextDecoder !== 'undefined' ? new TextDecoder('utf8') : undefined
  function UTF8ArrayToString(u8Array, idx) {
    var endPtr = idx
    while (u8Array[endPtr]) ++endPtr
    if (endPtr - idx > 16 && u8Array.subarray && UTF8Decoder) {
      return UTF8Decoder.decode(u8Array.subarray(idx, endPtr))
    } else {
      var u0, u1, u2, u3, u4, u5
      var str = ''
      while (1) {
        u0 = u8Array[idx++]
        if (!u0) return str
        if (!(u0 & 128)) {
          str += String.fromCharCode(u0)
          continue
        }
        u1 = u8Array[idx++] & 63
        if ((u0 & 224) == 192) {
          str += String.fromCharCode(((u0 & 31) << 6) | u1)
          continue
        }
        u2 = u8Array[idx++] & 63
        if ((u0 & 240) == 224) {
          u0 = ((u0 & 15) << 12) | (u1 << 6) | u2
        } else {
          u3 = u8Array[idx++] & 63
          if ((u0 & 248) == 240) {
            u0 = ((u0 & 7) << 18) | (u1 << 12) | (u2 << 6) | u3
          } else {
            u4 = u8Array[idx++] & 63
            if ((u0 & 252) == 248) {
              u0 = ((u0 & 3) << 24) | (u1 << 18) | (u2 << 12) | (u3 << 6) | u4
            } else {
              u5 = u8Array[idx++] & 63
              u0 = ((u0 & 1) << 30) | (u1 << 24) | (u2 << 18) | (u3 << 12) | (u4 << 6) | u5
            }
          }
        }
        if (u0 < 65536) {
          str += String.fromCharCode(u0)
        } else {
          var ch = u0 - 65536
          str += String.fromCharCode(55296 | (ch >> 10), 56320 | (ch & 1023))
        }
      }
    }
  }
  function UTF8ToString(ptr) {
    return UTF8ArrayToString(HEAPU8, ptr)
  }
  var UTF16Decoder = typeof TextDecoder !== 'undefined' ? new TextDecoder('utf-16le') : undefined
  var WASM_PAGE_SIZE = 65536
  var ASMJS_PAGE_SIZE = 16777216
  var MIN_TOTAL_MEMORY = 16777216
  function alignUp(x, multiple) {
    if (x % multiple > 0) {
      x += multiple - x % multiple
    }
    return x
  }
  var buffer, HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64
  function updateGlobalBuffer(buf) {
    Module['buffer'] = buffer = buf
  }
  function updateGlobalBufferViews() {
    Module['HEAP8'] = HEAP8 = new Int8Array(buffer)
    Module['HEAP16'] = HEAP16 = new Int16Array(buffer)
    Module['HEAP32'] = HEAP32 = new Int32Array(buffer)
    Module['HEAPU8'] = HEAPU8 = new Uint8Array(buffer)
    Module['HEAPU16'] = HEAPU16 = new Uint16Array(buffer)
    Module['HEAPU32'] = HEAPU32 = new Uint32Array(buffer)
    Module['HEAPF32'] = HEAPF32 = new Float32Array(buffer)
    Module['HEAPF64'] = HEAPF64 = new Float64Array(buffer)
  }
  var STATIC_BASE, STATICTOP, staticSealed
  var STACK_BASE, STACKTOP, STACK_MAX
  var DYNAMIC_BASE, DYNAMICTOP_PTR
  STATIC_BASE = STATICTOP = STACK_BASE = STACKTOP = STACK_MAX = DYNAMIC_BASE = DYNAMICTOP_PTR = 0
  staticSealed = false
  if (!Module['reallocBuffer'])
    Module['reallocBuffer'] = function(size) {
      var ret
      try {
        if (ArrayBuffer.transfer) {
          ret = ArrayBuffer.transfer(buffer, size)
        } else {
          var oldHEAP8 = HEAP8
          ret = new ArrayBuffer(size)
          var temp = new Int8Array(ret)
          temp.set(oldHEAP8)
        }
      } catch (e) {
        return false
      }
      var success = _emscripten_replace_memory(ret)
      if (!success) return false
      return ret
    }
  function enlargeMemory() {
    var PAGE_MULTIPLE = Module['usingWasm'] ? WASM_PAGE_SIZE : ASMJS_PAGE_SIZE
    var LIMIT = 2147483648 - PAGE_MULTIPLE
    if (HEAP32[DYNAMICTOP_PTR >> 2] > LIMIT) {
      return false
    }
    var OLD_TOTAL_MEMORY = TOTAL_MEMORY
    TOTAL_MEMORY = Math.max(TOTAL_MEMORY, MIN_TOTAL_MEMORY)
    while (TOTAL_MEMORY < HEAP32[DYNAMICTOP_PTR >> 2]) {
      if (TOTAL_MEMORY <= 536870912) {
        TOTAL_MEMORY = alignUp(2 * TOTAL_MEMORY, PAGE_MULTIPLE)
      } else {
        TOTAL_MEMORY = Math.min(alignUp((3 * TOTAL_MEMORY + 2147483648) / 4, PAGE_MULTIPLE), LIMIT)
      }
    }
    var replacement = Module['reallocBuffer'](TOTAL_MEMORY)
    if (!replacement || replacement.byteLength != TOTAL_MEMORY) {
      TOTAL_MEMORY = OLD_TOTAL_MEMORY
      return false
    }
    updateGlobalBuffer(replacement)
    updateGlobalBufferViews()
    return true
  }
  var byteLength
  try {
    byteLength = Function.prototype.call.bind(Object.getOwnPropertyDescriptor(ArrayBuffer.prototype, 'byteLength').get)
    byteLength(new ArrayBuffer(4))
  } catch (e) {
    byteLength = function(buffer) {
      return buffer.byteLength
    }
  }
  var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880
  var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 16777216
  if (TOTAL_MEMORY < TOTAL_STACK) Module.printErr('TOTAL_MEMORY should be larger than TOTAL_STACK, was ' + TOTAL_MEMORY + '! (TOTAL_STACK=' + TOTAL_STACK + ')')
  if (Module['buffer']) {
    buffer = Module['buffer']
  } else {
    if (typeof WebAssembly === 'object' && typeof WebAssembly.Memory === 'function') {
      Module['wasmMemory'] = new WebAssembly.Memory({
        initial: TOTAL_MEMORY / WASM_PAGE_SIZE
      })
      buffer = Module['wasmMemory'].buffer
    } else {
      buffer = new ArrayBuffer(TOTAL_MEMORY)
    }
    Module['buffer'] = buffer
  }
  updateGlobalBufferViews()
  function getTotalMemory() {
    return TOTAL_MEMORY
  }
  HEAP32[0] = 1668509029
  HEAP16[1] = 25459
  if (HEAPU8[2] !== 115 || HEAPU8[3] !== 99) throw 'Runtime error: expected the system to be little-endian!'
  function callRuntimeCallbacks(callbacks) {
    while (callbacks.length > 0) {
      var callback = callbacks.shift()
      if (typeof callback == 'function') {
        callback()
        continue
      }
      var func = callback.func
      if (typeof func === 'number') {
        if (callback.arg === undefined) {
          Module['dynCall_v'](func)
        } else {
          Module['dynCall_vi'](func, callback.arg)
        }
      } else {
        func(callback.arg === undefined ? null : callback.arg)
      }
    }
  }
  var __ATPRERUN__ = []
  var __ATINIT__ = []
  var __ATMAIN__ = []
  var __ATEXIT__ = []
  var __ATPOSTRUN__ = []
  var runtimeInitialized = false
  var runtimeExited = false
  function preRun() {
    if (Module['preRun']) {
      if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']]
      while (Module['preRun'].length) {
        addOnPreRun(Module['preRun'].shift())
      }
    }
    callRuntimeCallbacks(__ATPRERUN__)
  }
  function ensureInitRuntime() {
    if (runtimeInitialized) return
    runtimeInitialized = true
    callRuntimeCallbacks(__ATINIT__)
  }
  function preMain() {
    callRuntimeCallbacks(__ATMAIN__)
  }
  function exitRuntime() {
    callRuntimeCallbacks(__ATEXIT__)
    runtimeExited = true
  }
  function postRun() {
    if (Module['postRun']) {
      if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']]
      while (Module['postRun'].length) {
        addOnPostRun(Module['postRun'].shift())
      }
    }
    callRuntimeCallbacks(__ATPOSTRUN__)
  }
  function addOnPreRun(cb) {
    __ATPRERUN__.unshift(cb)
  }
  function addOnPostRun(cb) {
    __ATPOSTRUN__.unshift(cb)
  }
  var Math_abs = Math.abs
  var Math_cos = Math.cos
  var Math_sin = Math.sin
  var Math_tan = Math.tan
  var Math_acos = Math.acos
  var Math_asin = Math.asin
  var Math_atan = Math.atan
  var Math_atan2 = Math.atan2
  var Math_exp = Math.exp
  var Math_log = Math.log
  var Math_sqrt = Math.sqrt
  var Math_ceil = Math.ceil
  var Math_floor = Math.floor
  var Math_pow = Math.pow
  var Math_imul = Math.imul
  var Math_fround = Math.fround
  var Math_round = Math.round
  var Math_min = Math.min
  var Math_max = Math.max
  var Math_clz32 = Math.clz32
  var Math_trunc = Math.trunc
  var runDependencies = 0
  var runDependencyWatcher = null
  var dependenciesFulfilled = null
  function addRunDependency(id) {
    runDependencies++
    if (Module['monitorRunDependencies']) {
      Module['monitorRunDependencies'](runDependencies)
    }
  }
  function removeRunDependency(id) {
    runDependencies--
    if (Module['monitorRunDependencies']) {
      Module['monitorRunDependencies'](runDependencies)
    }
    if (runDependencies == 0) {
      if (runDependencyWatcher !== null) {
        clearInterval(runDependencyWatcher)
        runDependencyWatcher = null
      }
      if (dependenciesFulfilled) {
        var callback = dependenciesFulfilled
        dependenciesFulfilled = null
        callback()
      }
    }
  }
  Module['preloadedImages'] = {}
  Module['preloadedAudios'] = {}
  var dataURIPrefix = 'data:application/octet-stream;base64,'
  function isDataURI(filename) {
    return String.prototype.startsWith ? filename.startsWith(dataURIPrefix) : filename.indexOf(dataURIPrefix) === 0
  }
  function integrateWasmJS() {
    var wasmTextFile = 'roaring-wasm-module.wast'
    var wasmBinaryFile = 'roaring-wasm-module.wasm'
    var asmjsCodeFile = 'roaring-wasm-module.temp.asm.js'
    if (typeof Module['locateFile'] === 'function') {
      if (!isDataURI(wasmTextFile)) {
        wasmTextFile = Module['locateFile'](wasmTextFile)
      }
      if (!isDataURI(wasmBinaryFile)) {
        wasmBinaryFile = Module['locateFile'](wasmBinaryFile)
      }
      if (!isDataURI(asmjsCodeFile)) {
        asmjsCodeFile = Module['locateFile'](asmjsCodeFile)
      }
    }
    var wasmPageSize = 64 * 1024
    var info = {
      global: null,
      env: null,
      asm2wasm: {
        'f64-rem': function(x, y) {
          return x % y
        },
        debugger: function() {
          debugger
        }
      },
      parent: Module
    }
    var exports = null
    function mergeMemory(newBuffer) {
      var oldBuffer = Module['buffer']
      if (newBuffer.byteLength < oldBuffer.byteLength) {
        Module['printErr']('the new buffer in mergeMemory is smaller than the previous one. in native wasm, we should grow memory here')
      }
      var oldView = new Int8Array(oldBuffer)
      var newView = new Int8Array(newBuffer)
      newView.set(oldView)
      updateGlobalBuffer(newBuffer)
      updateGlobalBufferViews()
    }
    function fixImports(imports) {
      return imports
    }
    function getBinary() {
      try {
        if (Module['wasmBinary']) {
          return new Uint8Array(Module['wasmBinary'])
        }
        if (Module['readBinary']) {
          return Module['readBinary'](wasmBinaryFile)
        } else {
          throw "on the web, we need the wasm binary to be preloaded and set on Module['wasmBinary']. emcc.py will do that for you when generating HTML (but not JS)"
        }
      } catch (err) {
        abort(err)
      }
    }
    function doNativeWasm(global, env, providedBuffer) {
      if (typeof WebAssembly !== 'object') {
        Module['printErr']('no native wasm support detected')
        return false
      }
      if (!(Module['wasmMemory'] instanceof WebAssembly.Memory)) {
        Module['printErr']('no native wasm Memory in use')
        return false
      }
      env['memory'] = Module['wasmMemory']
      info['global'] = {
        NaN: NaN,
        Infinity: Infinity
      }
      info['global.Math'] = Math
      info['env'] = env
      function receiveInstance(instance, module) {
        exports = instance.exports
        if (exports.memory) mergeMemory(exports.memory)
        Module['asm'] = exports
        Module['usingWasm'] = true
        removeRunDependency('wasm-instantiate')
      }
      addRunDependency('wasm-instantiate')
      if (Module['instantiateWasm']) {
        try {
          return Module['instantiateWasm'](info, receiveInstance)
        } catch (e) {
          Module['printErr']('Module.instantiateWasm callback failed with error: ' + e)
          return false
        }
      }
      var instance
      try {
        instance = new WebAssembly.Instance(new WebAssembly.Module(getBinary()), info)
      } catch (e) {
        Module['printErr']('failed to compile wasm module: ' + e)
        if (e.toString().indexOf('imported Memory with incompatible size') >= 0) {
          Module['printErr']('Memory size incompatibility issues may be due to changing TOTAL_MEMORY at runtime to something too large. Use ALLOW_MEMORY_GROWTH to allow any size memory (and also make sure not to set TOTAL_MEMORY at runtime to something smaller than it was at compile time).')
        }
        return false
      }
      receiveInstance(instance)
      return exports
    }
    Module['asmPreload'] = Module['asm']
    var asmjsReallocBuffer = Module['reallocBuffer']
    var wasmReallocBuffer = function(size) {
      var PAGE_MULTIPLE = Module['usingWasm'] ? WASM_PAGE_SIZE : ASMJS_PAGE_SIZE
      size = alignUp(size, PAGE_MULTIPLE)
      var old = Module['buffer']
      var oldSize = old.byteLength
      if (Module['usingWasm']) {
        try {
          var result = Module['wasmMemory'].grow((size - oldSize) / wasmPageSize)
          if (result !== (-1 | 0)) {
            return (Module['buffer'] = Module['wasmMemory'].buffer)
          } else {
            return null
          }
        } catch (e) {
          return null
        }
      }
    }
    Module['reallocBuffer'] = function(size) {
      if (finalMethod === 'asmjs') {
        return asmjsReallocBuffer(size)
      } else {
        return wasmReallocBuffer(size)
      }
    }
    var finalMethod = ''
    Module['asm'] = function(global, env, providedBuffer) {
      env = fixImports(env)
      if (!env['table']) {
        var TABLE_SIZE = Module['wasmTableSize']
        if (TABLE_SIZE === undefined) TABLE_SIZE = 1024
        var MAX_TABLE_SIZE = Module['wasmMaxTableSize']
        if (typeof WebAssembly === 'object' && typeof WebAssembly.Table === 'function') {
          if (MAX_TABLE_SIZE !== undefined) {
            env['table'] = new WebAssembly.Table({
              initial: TABLE_SIZE,
              maximum: MAX_TABLE_SIZE,
              element: 'anyfunc'
            })
          } else {
            env['table'] = new WebAssembly.Table({
              initial: TABLE_SIZE,
              element: 'anyfunc'
            })
          }
        } else {
          env['table'] = new Array(TABLE_SIZE)
        }
        Module['wasmTable'] = env['table']
      }
      if (!env['memoryBase']) {
        env['memoryBase'] = Module['STATIC_BASE']
      }
      if (!env['tableBase']) {
        env['tableBase'] = 0
      }
      var exports
      exports = doNativeWasm(global, env, providedBuffer)
      if (!exports) abort('no binaryen method succeeded. consider enabling more options, like interpreting, if you want that: https://github.com/kripken/emscripten/wiki/WebAssembly#binaryen-methods')
      return exports
    }
  }
  integrateWasmJS()
  STATIC_BASE = GLOBAL_BASE
  STATICTOP = STATIC_BASE + 2976
  __ATINIT__.push()
  var STATIC_BUMP = 2976
  Module['STATIC_BASE'] = STATIC_BASE
  Module['STATIC_BUMP'] = STATIC_BUMP
  STATICTOP += 16
  function ___assert_fail(condition, filename, line, func) {
    abort('Assertion failed: ' + Pointer_stringify(condition) + ', at: ' + [filename ? Pointer_stringify(filename) : 'unknown filename', line, func ? Pointer_stringify(func) : 'unknown function'])
  }
  var cttz_i8 = allocate([8, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 6, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 7, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 6, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0], 'i8', ALLOC_STATIC)
  function _llvm_cttz_i32(x) {
    x = x | 0
    var ret = 0
    ret = HEAP8[(cttz_i8 + (x & 255)) >> 0] | 0
    if ((ret | 0) < 8) return ret | 0
    ret = HEAP8[(cttz_i8 + ((x >> 8) & 255)) >> 0] | 0
    if ((ret | 0) < 8) return (ret + 8) | 0
    ret = HEAP8[(cttz_i8 + ((x >> 16) & 255)) >> 0] | 0
    if ((ret | 0) < 8) return (ret + 16) | 0
    return ((HEAP8[(cttz_i8 + (x >>> 24)) >> 0] | 0) + 24) | 0
  }
  function _llvm_cttz_i64(l, h) {
    var ret = _llvm_cttz_i32(l)
    if (ret == 32) ret += _llvm_cttz_i32(h)
    return (setTempRet0(0), ret) | 0
  }
  function _emscripten_memcpy_big(dest, src, num) {
    HEAPU8.set(HEAPU8.subarray(src, src + num), dest)
    return dest
  }
  function ___setErrNo(value) {
    if (Module['___errno_location']) HEAP32[Module['___errno_location']() >> 2] = value
    return value
  }
  DYNAMICTOP_PTR = staticAlloc(4)
  STACK_BASE = STACKTOP = alignMemory(STATICTOP)
  STACK_MAX = STACK_BASE + TOTAL_STACK
  DYNAMIC_BASE = alignMemory(STACK_MAX)
  HEAP32[DYNAMICTOP_PTR >> 2] = DYNAMIC_BASE
  staticSealed = true
  Module['wasmTableSize'] = 0
  Module['wasmMaxTableSize'] = 0
  Module.asmGlobalArg = {}
  Module.asmLibraryArg = {
    enlargeMemory: enlargeMemory,
    getTotalMemory: getTotalMemory,
    ___assert_fail: ___assert_fail,
    ___setErrNo: ___setErrNo,
    _emscripten_memcpy_big: _emscripten_memcpy_big,
    _llvm_cttz_i64: _llvm_cttz_i64,
    DYNAMICTOP_PTR: DYNAMICTOP_PTR,
    STACKTOP: STACKTOP
  }
  var asm = Module['asm'](Module.asmGlobalArg, Module.asmLibraryArg, buffer)
  var _emscripten_replace_memory = (Module['_emscripten_replace_memory'] = asm['_emscripten_replace_memory'])
  var _free = (Module['_free'] = asm['_free'])
  var _get_sizeof_roaring_bitmap_t = (Module['_get_sizeof_roaring_bitmap_t'] = asm['_get_sizeof_roaring_bitmap_t'])
  var _malloc = (Module['_malloc'] = asm['_malloc'])
  var _roaring_bitmap_add = (Module['_roaring_bitmap_add'] = asm['_roaring_bitmap_add'])
  var _roaring_bitmap_add_checked_js = (Module['_roaring_bitmap_add_checked_js'] = asm['_roaring_bitmap_add_checked_js'])
  var _roaring_bitmap_add_many = (Module['_roaring_bitmap_add_many'] = asm['_roaring_bitmap_add_many'])
  var _roaring_bitmap_and_cardinality = (Module['_roaring_bitmap_and_cardinality'] = asm['_roaring_bitmap_and_cardinality'])
  var _roaring_bitmap_and_inplace = (Module['_roaring_bitmap_and_inplace'] = asm['_roaring_bitmap_and_inplace'])
  var _roaring_bitmap_andnot_cardinality = (Module['_roaring_bitmap_andnot_cardinality'] = asm['_roaring_bitmap_andnot_cardinality'])
  var _roaring_bitmap_andnot_inplace = (Module['_roaring_bitmap_andnot_inplace'] = asm['_roaring_bitmap_andnot_inplace'])
  var _roaring_bitmap_contains = (Module['_roaring_bitmap_contains'] = asm['_roaring_bitmap_contains'])
  var _roaring_bitmap_create_js = (Module['_roaring_bitmap_create_js'] = asm['_roaring_bitmap_create_js'])
  var _roaring_bitmap_equals = (Module['_roaring_bitmap_equals'] = asm['_roaring_bitmap_equals'])
  var _roaring_bitmap_flip_inplace = (Module['_roaring_bitmap_flip_inplace'] = asm['_roaring_bitmap_flip_inplace'])
  var _roaring_bitmap_free = (Module['_roaring_bitmap_free'] = asm['_roaring_bitmap_free'])
  var _roaring_bitmap_get_cardinality = (Module['_roaring_bitmap_get_cardinality'] = asm['_roaring_bitmap_get_cardinality'])
  var _roaring_bitmap_intersect = (Module['_roaring_bitmap_intersect'] = asm['_roaring_bitmap_intersect'])
  var _roaring_bitmap_is_empty = (Module['_roaring_bitmap_is_empty'] = asm['_roaring_bitmap_is_empty'])
  var _roaring_bitmap_is_strict_subset = (Module['_roaring_bitmap_is_strict_subset'] = asm['_roaring_bitmap_is_strict_subset'])
  var _roaring_bitmap_is_subset = (Module['_roaring_bitmap_is_subset'] = asm['_roaring_bitmap_is_subset'])
  var _roaring_bitmap_jaccard_index = (Module['_roaring_bitmap_jaccard_index'] = asm['_roaring_bitmap_jaccard_index'])
  var _roaring_bitmap_maximum = (Module['_roaring_bitmap_maximum'] = asm['_roaring_bitmap_maximum'])
  var _roaring_bitmap_minimum = (Module['_roaring_bitmap_minimum'] = asm['_roaring_bitmap_minimum'])
  var _roaring_bitmap_native_deserialize_js = (Module['_roaring_bitmap_native_deserialize_js'] = asm['_roaring_bitmap_native_deserialize_js'])
  var _roaring_bitmap_native_serialize_js = (Module['_roaring_bitmap_native_serialize_js'] = asm['_roaring_bitmap_native_serialize_js'])
  var _roaring_bitmap_native_size_in_bytes_js = (Module['_roaring_bitmap_native_size_in_bytes_js'] = asm['_roaring_bitmap_native_size_in_bytes_js'])
  var _roaring_bitmap_optimize_js = (Module['_roaring_bitmap_optimize_js'] = asm['_roaring_bitmap_optimize_js'])
  var _roaring_bitmap_or_cardinality = (Module['_roaring_bitmap_or_cardinality'] = asm['_roaring_bitmap_or_cardinality'])
  var _roaring_bitmap_or_inplace = (Module['_roaring_bitmap_or_inplace'] = asm['_roaring_bitmap_or_inplace'])
  var _roaring_bitmap_portable_deserialize_js = (Module['_roaring_bitmap_portable_deserialize_js'] = asm['_roaring_bitmap_portable_deserialize_js'])
  var _roaring_bitmap_portable_serialize_js = (Module['_roaring_bitmap_portable_serialize_js'] = asm['_roaring_bitmap_portable_serialize_js'])
  var _roaring_bitmap_portable_size_in_bytes = (Module['_roaring_bitmap_portable_size_in_bytes'] = asm['_roaring_bitmap_portable_size_in_bytes'])
  var _roaring_bitmap_rank = (Module['_roaring_bitmap_rank'] = asm['_roaring_bitmap_rank'])
  var _roaring_bitmap_remove = (Module['_roaring_bitmap_remove'] = asm['_roaring_bitmap_remove'])
  var _roaring_bitmap_remove_checked_js = (Module['_roaring_bitmap_remove_checked_js'] = asm['_roaring_bitmap_remove_checked_js'])
  var _roaring_bitmap_select_js = (Module['_roaring_bitmap_select_js'] = asm['_roaring_bitmap_select_js'])
  var _roaring_bitmap_to_uint32_array = (Module['_roaring_bitmap_to_uint32_array'] = asm['_roaring_bitmap_to_uint32_array'])
  var _roaring_bitmap_xor_cardinality = (Module['_roaring_bitmap_xor_cardinality'] = asm['_roaring_bitmap_xor_cardinality'])
  var _roaring_bitmap_xor_inplace = (Module['_roaring_bitmap_xor_inplace'] = asm['_roaring_bitmap_xor_inplace'])
  var setTempRet0 = (Module['setTempRet0'] = asm['setTempRet0'])
  var stackAlloc = (Module['stackAlloc'] = asm['stackAlloc'])
  Module['asm'] = asm
  Module['then'] = function(func) {
    if (Module['calledRun']) {
      func(Module)
    } else {
      var old = Module['onRuntimeInitialized']
      Module['onRuntimeInitialized'] = function() {
        if (old) old()
        func(Module)
      }
    }
    return Module
  }
  function ExitStatus(status) {
    this.name = 'ExitStatus'
    this.message = 'Program terminated with exit(' + status + ')'
    this.status = status
  }
  ExitStatus.prototype = new Error()
  ExitStatus.prototype.constructor = ExitStatus
  var initialStackTop
  dependenciesFulfilled = function runCaller() {
    if (!Module['calledRun']) run()
    if (!Module['calledRun']) dependenciesFulfilled = runCaller
  }
  function run(args) {
    args = args || Module['arguments']
    if (runDependencies > 0) {
      return
    }
    preRun()
    if (runDependencies > 0) return
    if (Module['calledRun']) return
    function doRun() {
      if (Module['calledRun']) return
      Module['calledRun'] = true
      if (ABORT) return
      ensureInitRuntime()
      preMain()
      if (Module['onRuntimeInitialized']) Module['onRuntimeInitialized']()
      postRun()
    }
    if (Module['setStatus']) {
      Module['setStatus']('Running...')
      setTimeout(function() {
        setTimeout(function() {
          Module['setStatus']('')
        }, 1)
        doRun()
      }, 1)
    } else {
      doRun()
    }
  }
  Module['run'] = run
  function exit(status, implicit) {
    if (implicit && Module['noExitRuntime'] && status === 0) {
      return
    }
    if (Module['noExitRuntime']) {
    } else {
      ABORT = true
      EXITSTATUS = status
      STACKTOP = initialStackTop
      exitRuntime()
      if (Module['onExit']) Module['onExit'](status)
    }
    if (ENVIRONMENT_IS_NODE) {
      process['exit'](status)
    }
    Module['quit'](status, new ExitStatus(status))
  }
  Module['exit'] = exit
  function abort(what) {
    if (Module['onAbort']) {
      Module['onAbort'](what)
    }
    if (what !== undefined) {
      Module.print(what)
      Module.printErr(what)
      what = JSON.stringify(what)
    } else {
      what = ''
    }
    ABORT = true
    EXITSTATUS = 1
    throw 'abort(' + what + '). Build with -s ASSERTIONS=1 for more info.'
  }
  Module['abort'] = abort
  if (Module['preInit']) {
    if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']]
    while (Module['preInit'].length > 0) {
      Module['preInit'].pop()()
    }
  }
  Module['noExitRuntime'] = true
  run()

  return roaring_wasm_module
}
if (typeof exports === 'object' && typeof module === 'object') module.exports = roaring_wasm_module
else if (typeof define === 'function' && define['amd'])
  define([], function() {
    return roaring_wasm_module
  })
else if (typeof exports === 'object') exports['roaring_wasm_module'] = roaring_wasm_module
